
local SEARCH_IN_PROGRESS = false

--=====================================--
--======== DONT NEED CHANGED ==========--
--=====================================--
local function GetIsCaseSens()
	if CLICK4INFO.caseSens:GetState() == BSTATE_PRESSED then
		return true
	end
	return false
end

local function ClearCategoryItems(categoryId)
	local scrollList = CLICK4INFO.scrollList
	local dataList = ZO_ScrollList_GetDataList(scrollList)
	local j = 1
	for i=#dataList, 1, -1 do
		if dataList[i].categoryId == categoryId then
			j = j + 1
			table.remove(dataList, i)
		end
	end
	ZO_ScrollList_Commit(scrollList)
end


--=====================================--
--======== OTHER  ==========--
--=====================================--


--=====================================--
--======== SEARCH  ==========--
--=====================================--
local function DoValueSearch(categoryId, text)
	if (categoryId ~= CLICK4INFO_CATEGORY_VALUE) then return end
	
	local numSearchVal = tonumber(text)
	local strSearchTxtLower = string.lower(text)
	local isCaseSens		= GetIsCaseSens()
	-- removed & code edited to allow searching for string values
	--if not searchNumber then return end
	
	CLICK4INFO.sv.savedCommands[CLICK4INFO_CATEGORY_VALUE] = {}
	local searchResults 	= CLICK4INFO.sv.savedCommands[CLICK4INFO_CATEGORY_VALUE]
	
	for key, value in zo_insecurePairs(_G) do
		local numValFound = type(value) == "number" and value == numSearchVal
		local strValFound = type(value) == "string" and ((isCaseSens and value:find(text)) or (not isCaseSens and string.lower(value):find(strSearchTxtLower))) and not IsProtectedFunction(value)
		
		if numValFound or strValFound then
			table.insert(searchResults, {["name"] = key, ["value"] = value, ["categoryId"]=CLICK4INFO_CATEGORY_VALUE})
		end
	end
	return searchResults
end

--=====================================--
--======== xxxxx  ==========--
--=====================================--
local function GetSearchType(categoryId)
	if categoryId == CLICK4INFO_CATEGORY_FUNCTIONS then
		return "function"
	elseif categoryId == CLICK4INFO_CATEGORY_CONSTANTS then
		return "number", "string"
	elseif selectedCategory == CLICK4INFO_CATEGORY_VALUE then
		return "number"
	end
	return "string"
end

local function DoGlobalSearch(categoryId, text)
	if (categoryId ~= CLICK4INFO_CATEGORY_FUNCTIONS) and (categoryId ~= CLICK4INFO_CATEGORY_CONSTANTS)  and (categoryId ~= CLICK4INFO_CATEGORY_VALUE) then return end
	
	-- Constant search has 2 types: "number" & "string"
	local searchType1, searchType2 		= GetSearchType(categoryId)
	local isCaseSens		= GetIsCaseSens()
	CLICK4INFO.sv.savedCommands[categoryId] = {}
	local searchResults 	= CLICK4INFO.sv.savedCommands[categoryId]
	local searchText 		= text
	
	if not isCaseSens then
		searchText = text:lower()
	end
	
	for key, value in zo_insecurePairs(_G) do
		local valType = type(value)
		if valType == searchType1 or (searchType2 and valType == searchType2) then
			local searchKey = key
			
			if isCaseSens and key:find(searchText) 
			or not isCaseSens and string.lower(key):find(searchText) then
				table.insert(searchResults, {["name"] = key, ["value"] = value, ["categoryId"]=categoryId})
			end
		end
	end
	return searchResults
end
local function DoLocalSearch(categoryId, text)
	if (categoryId ~= CLICK4INFO_CATEGORY_ALL) and (categoryId ~= CLICK4INFO_CATEGORY_FAVORITES)  and (categoryId ~= CLICK4INFO_CATEGORY_SCRIPTS) then return end
	
	local isCaseSens		= GetIsCaseSens()
	local searchTable 		= Click4Info:GetCategoryIdTable(categoryId)
	local searchResults 	= {}
	local searchText 		= text
	
	if not isCaseSens then
		searchText = text:lower()
	end
	
	for key, dataTable in pairs(searchTable) do
		local name = dataTable.name
		
		if isCaseSens and name:find(searchText) 
		or not isCaseSens and string.lower(name):find(searchText) then
			table.insert(searchResults, {["name"] = name, ["value"] = dataTable.value, ["categoryId"]=dataTable.categoryId})
		end
	end
	return searchResults
end

function Click4Info_Search(searchText)
	if SEARCH_IN_PROGRESS then return end
	SEARCH_IN_PROGRESS 	= true
	--local searchText = editBox:GetText()
	local selectedCategory = CLICK4INFO.menuBar.m_object:GetSelectedDescriptor()
	
	-- NOTE: This also prevents the entire global table from being loaded
	-- They must enter something to search for to populate the category table
	-- Then if they back off to "" search text, it only reloads what was already saved
	-- Forcing max results of searching with 1 char, but since slash commands & scripts are
	-- ALL saved, it still redisplays ALL of them
	if not (searchText and type(searchText)=="string" and searchText ~= "") then 
	-- This was an idea to increase min string length, but abandoned
	-- It would prevent searching for values like: 1 or 12
	-- I could write even more code to work around it, but I don't think its that important
	--if not (searchText and type(searchText)=="string" and string.len(searchText) > 2) then 
		CLICK4INFO:UpdateScrollListByCategoryId(selectedCategory)
		SEARCH_IN_PROGRESS = false
		return
	end
	
	local searchResults = {}
	
	if selectedCategory == CLICK4INFO_CATEGORY_VALUE then
		searchResults 	= DoValueSearch(selectedCategory, searchText)
	elseif (selectedCategory == CLICK4INFO_CATEGORY_ALL) or (selectedCategory == CLICK4INFO_CATEGORY_FAVORITES)  or (selectedCategory == CLICK4INFO_CATEGORY_SCRIPTS) then
		searchResults = DoLocalSearch(selectedCategory, searchText)
	else
		searchResults = DoGlobalSearch(selectedCategory, searchText)
	end
	
	--CLICK4INFO:UpdateScrollListByCategoryId(categoryId)
	CLICK4INFO:UpdateScrollList(searchResults)
	
	SEARCH_IN_PROGRESS = false
end



